# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%bcond_without maven
%bcond_without repolib

%define reltag _redhat_1
%define namedreltag -redhat-1
%global namedversion %{version}%{?namedreltag}

%define section free

Name:           google-guice
Version:        3.0
Release:        2%{?reltag}%{?dist}
Epoch:          0
Summary:        Dependency Injection Framework
Group:          Development/Libraries
License:        ASL 2.0
URL:            http://code.google.com/p/google-guice/
# svn export -r 1576 http://google-guice.googlecode.com/svn/tags/3.0 google-guice-%{namedversion} && tar cjf google-guice-%{namedversion}.tar.bz2 google-guice-%{namedversion}
Source0:        google-guice-%{version}.tar.bz2
Patch0:         google-guice-pom.patch
Patch1:         google-guice-cglib.patch
Patch2:         google-guice-hsqldb.patch
Patch3:         google-guice-maven-compiler-plugin.patch
Patch4:         google-guice-munge.patch
Patch5:         google-guice-disable-animal-sniffer.patch
Patch6:         google-guice-pom-versions.patch
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       aopalliance >= 0:1.0
Requires:       javax.inject
Requires:       jpackage-utils
Requires:       objectweb-asm >= 0:3.3.1
Requires:       sisu-cglib >= 0:2.2.2
BuildRequires:  ant
BuildRequires:  animal-sniffer
BuildRequires:  aopalliance >= 0:1.0
BuildRequires:  apache-commons-parent
BuildRequires:  cglib >= 0:2.2
BuildRequires:  sisu-cglib >= 0:2.2.2
BuildRequires:  java-devel
BuildRequires:  jpackage-utils
BuildRequires:  junit4
BuildRequires:  maven2
BuildRequires:  maven2-plugin-antrun
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-remote-resources
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-site
BuildRequires:  maven2-plugin-source
BuildRequires:  maven2-plugin-surefire
BuildRequires:  maven-surefire-provider-testng
%if %with repolib
BuildRequires:  maven2-plugin-deploy
%endif
BuildRequires:  objectweb-asm >= 0:3.3.1
BuildRequires:  ognl
BuildRequires:  freemarker
BuildRequires:  google-parent >= 0:5
BuildRequires:  jarjar-maven-plugin >= 0:1.3
BuildRequires:  sonatype-plugins-parent
BuildRequires:  munge-maven-plugin >= 0:1.0
# XXX: circular (testng requires google-guice)
BuildRequires:  testng >= 0:5.11
# XXX: 3.0.5
BuildRequires:  felix-framework
BuildRequires:  maven-bundle-plugin
BuildRequires:  javax.inject >= 0:1
BuildRequires:  javax.inject-tck >= 0:1
BuildRequires:  spring2-beans
# 0.0.384
BuildRequires:  aqute-bndlib
# 3.0
BuildRequires:  easymock2
# FIXME: javax.persistence:persistence-api:jar:1.0
BuildRequires:  hibernate3-ejb-persistence-3.0-api
BuildRequires:  jboss-servlet-api_3.0_spec
BuildRequires:  hibernate3-entitymanager >= 0:3.4.0
BuildRequires:  hibernate3-search
# hsqldb-j5-2.0.0
BuildRequires:  hsqldb
BuildRequires:  slf4j
# XXX: 2.0
#BuildRequires:  struts2-core
BuildRequires:  jdiff
BuildRequires:  apache-jar-resource-bundle
BuildRequires:  mojo-signatures
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
Put simply, Guice alleviates the need for factories and the
use of new in your Java code. Think of Guice's @Inject as 
the new new. You will still need to write factories in some
cases, but your code will not depend directly on them. Your
code will be easier to change, unit test and reuse in other
contexts.

Guice embraces Java's type safe nature, especially when it 
comes to features introduced in Java 5 such as generics and
annotations. You might think of Guice as filling in missing
features for core Java. Ideally, the language itself would 
provide most of the same features, but until such a 
language comes along, we have Guice.

%package javadoc
Group:          Development/Documentation
Summary:        Javadoc for %{name}
Requires:       jpackage-utils

%description javadoc
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q
%patch0 -p1 -b .sav0
%patch1 -p1 -b .sav1
%patch2 -p1 -b .sav2
%patch3 -p1 -b .sav3
%patch4 -p1 -b .sav4
%patch5 -p1 -b .sav5
%patch6 -p1 -b .sav6
%{_bindir}/find -type f \( -name "*.jar" -and -not \( -name "doclava.jar" -or -name "munge.jar" -or -name "xwork*.jar" \) \) | %{_bindir}/xargs -t %{__rm}
%{__rm} -r javadoc latest-api-diffs latest-javadoc

%{__rm} -r extensions/persist/test
%{__rm} -r extensions/struts2/test

%if %without maven
%{__ln_s} `%{_bindir}/build-classpath antlr` extensions/persist/lib/antlr-2.7.5h3.jar
%{__ln_s} `%{_bindir}/build-classpath aopalliance` extensions/persist/lib/aopalliance.jar
# XXX: where is -nodep
%{__ln_s} `%{_bindir}/build-classpath cglib-nodep` extensions/persist/lib/cglib-nodep-2.2.jar
%{__ln_s} `%{_bindir}/build-classpath commons-collections` extensions/persist/lib/commons-collections.jar
%{__ln_s} `%{_bindir}/build-classpath commons-io` extensions/persist/lib/commons-io.jar
%{__ln_s} `%{_bindir}/build-classpath commons-logging` extensions/persist/lib/commons-logging-1.0.4.jar
%if 0
%{__ln_s} `%{_bindir}/build-classpath maven2/empty-dep` extensions/persist/lib/db4o-6.4.14.8131-java5.jar
%endif
%{__ln_s} `%{_bindir}/build-classpath dom4j` extensions/persist/lib/dom4j-1.6.1.jar
# XXX: need 3.0
%{__ln_s} `%{_bindir}/build-classpath easymock2` extensions/persist/lib/easymock.jar
%{__ln_s} `%{_bindir}/build-classpath jpa_api` extensions/persist/lib/ejb3-persistence.jar
%{__ln_s} `%{_bindir}/build-classpath hibernate3-core` extensions/persist/lib/hibernate3.jar
%{__ln_s} `%{_bindir}/build-classpath hibernate3-annotations` extensions/persist/lib/hibernate-annotations.jar
%{__ln_s} `%{_bindir}/build-classpath hibernate3-entitymanager` extensions/persist/lib/hibernate-entitymanager.jar
%{__ln_s} `%{_bindir}/build-classpath hibernate3-search` extensions/persist/lib/hibernate-search.jar
# XXX: need 2.0
%{__ln_s} `%{_bindir}/build-classpath hsqldb` extensions/persist/lib/hsqldb.jar
%{__ln_s} `%{_bindir}/build-classpath javassist` extensions/persist/lib/javassist.jar
%{__ln_s} `%{_bindir}/build-classpath jaxen` extensions/persist/lib/jaxen-1.1-beta-7.jar
%if 0
%{__ln_s} `%{_bindir}/build-classpath maven2/empty-dep` extensions/persist/lib/jboss-archive-browsing.jar
%endif
%{__ln_s} `%{_bindir}/build-classpath jta_api` extensions/persist/lib/jta.jar
%{__ln_s} `%{_bindir}/build-classpath log4j` extensions/persist/lib/log4j-1.2.14.jar
%{__ln_s} `%{_bindir}/build-classpath ognl` extensions/persist/lib/ognl-2.6.7.jar
%{__ln_s} `%{_bindir}/build-classpath oro` extensions/persist/lib/oro-2.0.8.jar
%{__ln_s} `%{_bindir}/build-classpath servlet_api` extensions/persist/lib/servlet-api-2.5.jar
%if 0
%{__ln_s} `%{_bindir}/build-classpath xwork` extensions/persist/lib/xwork-2.0.4.jar
%endif
%{__ln_s} `%{_bindir}/build-classpath servlet_api` extensions/servlet/lib/build/servlet-api-2.5.jar
%{__ln_s} `%{_bindir}/build-classpath ant` extensions/struts2/lib/ant-1.6.5.jar
%{__ln_s} `%{_bindir}/build-classpath commons-fileupload` extensions/struts2/lib/commons-fileupload-1.2.1.jar
%{__ln_s} `%{_bindir}/build-classpath commons-io` extensions/struts2/lib/commons-io-1.3.2.jar
%{__ln_s} `%{_bindir}/build-classpath commons-logging` extensions/struts2/lib/commons-logging-1.0.4.jar
%{__ln_s} `%{_bindir}/build-classpath ecj3` extensions/struts2/lib/core-3.1.1.jar
%{__ln_s} `%{_bindir}/build-classpath freemarker` extensions/struts2/lib/freemarker-2.3.16.jar
%{__ln_s} `%{_bindir}/build-classpath javassist` extensions/struts2/lib/javassist.jar
%{__ln_s} `%{_bindir}/build-classpath jetty6/core/jetty6` extensions/struts2/lib/jetty-6.1.0.jar
%{__ln_s} `%{_bindir}/build-classpath jetty6/jetty6-util` extensions/struts2/lib/jetty-util-6.1.0.jar
%{__ln_s} `%{_bindir}/build-classpath jsp_api` extensions/struts2/lib/jsp-2.1.jar
%{__ln_s} `%{_bindir}/build-classpath jsp_api` extensions/struts2/lib/jsp-api-2.1.jar
%{__ln_s} `%{_bindir}/build-classpath ognl` extensions/struts2/lib/ognl-%{namedversion}.jar
%{__ln_s} `%{_bindir}/build-classpath servlet_api` extensions/struts2/lib/servlet-api-2.5.jar
%{__ln_s} `%{_bindir}/build-classpath struts` extensions/struts2/lib/struts2-core-2.2.1.jar
%if 0
%{__ln_s} `%{_bindir}/build-classpath xwork-core` extensions/struts2/lib/xwork-core-2.2.1.jar
%endif
%{__ln_s} `%{_bindir}/build-classpath aopalliance` lib/aopalliance.jar
%{__ln_s} `%{_bindir}/build-classpath objectweb-asm/asm` lib/build/asm-3.1.jar
%{__ln_s} `%{_bindir}/build-classpath aqute-bndlib` lib/build/bnd-0.0.384.jar
%{__ln_s} `%{_bindir}/build-classpath cglib` lib/build/cglib-2.2.1-snapshot.jar
%{__ln_s} `%{_bindir}/build-classpath commons-logging` lib/build/commons-logging-1.0.4.jar
# XXX: what is this
%if 0
%{__ln_s} `%{_bindir}/build-classpath maven2/empty-dep` lib/build/doclava.jar
%endif
# XXX: need 3.0
%{__ln_s} `%{_bindir}/build-classpath easymock2` lib/build/easymock.jar
%{__ln_s} `%{_bindir}/build-classpath org.osgi.core` lib/build/felix-2.0.5.jar
%{__ln_s} `%{_bindir}/build-classpath jarjar` lib/build/jarjar-snapshot.jar
%{__ln_s} `%{_bindir}/build-classpath javax.inject-tck` lib/build/javax.inject-tck.jar
%{__ln_s} `%{_bindir}/build-classpath jdiff` lib/build/jdiff/jdiff.jar
%{__ln_s} `%{_bindir}/build-classpath xerces-j2` lib/build/jdiff/xerces.jar
%{__ln_s} `%{_bindir}/build-classpath junit4` lib/build/junit.jar
# XXX
%if 0
%{__ln_s} `%{_bindir}/build-classpath munge-maven-plugin` lib/build/munge.jar
%endif
%if 0
# XXX: what is this
%{__ln_s} `%{_bindir}/build-classpath maven2/empty-dep` lib/build/safesax.jar
%endif
# XXX: need 3.0.5
%{__ln_s} `%{_bindir}/build-classpath spring2/spring-beans` lib/build/spring-beans.jar
%{__ln_s} `%{_bindir}/build-classpath spring2/spring-core` lib/build/spring-core.jar
%{__ln_s} `%{_bindir}/build-classpath javax.inject` lib/javax.inject.jar
%endif

%build
%if %with maven
export MAVEN_REPO_LOCAL=`pwd`/m2_repo/repository
export ALT_DEPLOYMENT_REPOSITORY_URL=oss-releases::default::file://`pwd`/maven2-brew
export MAVEN_OPTS="-Xms1g -Xmx1g"
%{_bindir}/mvn-jpp -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DaltDeploymentRepository=${ALT_DEPLOYMENT_REPOSITORY_URL} -Dmaven.test.failure.ignore=true package source:jar javadoc:aggregate-jar deploy javadoc:aggregate
%else
export CLASSPATH=    
export OPT_JAR_LIST=:
%{ant} -Dversion=%{namedversion} dist
%endif

%install
%{__rm} -rf %{buildroot}

%if %with maven
# jars
%{__mkdir_p} %{buildroot}%{_javadir}
%{__cp} -p maven2-brew/com/google/inject/extensions/guice-assistedinject/%{namedversion}/guice-assistedinject-%{namedversion}-tests.jar %{buildroot}%{_javadir}/guice-assistedinject-%{namedversion}-tests.jar
%{__cp} -p maven2-brew/com/google/inject/extensions/guice-assistedinject/%{namedversion}/guice-assistedinject-%{namedversion}.jar %{buildroot}%{_javadir}/guice-assistedinject-%{namedversion}.jar
%{__cp} -p maven2-brew/com/google/inject/extensions/guice-grapher/%{namedversion}/guice-grapher-%{namedversion}-tests.jar %{buildroot}%{_javadir}/guice-grapher-%{namedversion}-tests.jar
%{__cp} -p maven2-brew/com/google/inject/extensions/guice-grapher/%{namedversion}/guice-grapher-%{namedversion}.jar %{buildroot}%{_javadir}/guice-grapher-%{namedversion}.jar
%{__cp} -p maven2-brew/com/google/inject/extensions/guice-jmx/%{namedversion}/guice-jmx-%{namedversion}-tests.jar %{buildroot}%{_javadir}/guice-jmx-%{namedversion}-tests.jar
%{__cp} -p maven2-brew/com/google/inject/extensions/guice-jmx/%{namedversion}/guice-jmx-%{namedversion}.jar %{buildroot}%{_javadir}/guice-jmx-%{namedversion}.jar
%{__cp} -p maven2-brew/com/google/inject/extensions/guice-jndi/%{namedversion}/guice-jndi-%{namedversion}-tests.jar %{buildroot}%{_javadir}/guice-jndi-%{namedversion}-tests.jar
%{__cp} -p maven2-brew/com/google/inject/extensions/guice-jndi/%{namedversion}/guice-jndi-%{namedversion}.jar %{buildroot}%{_javadir}/guice-jndi-%{namedversion}.jar
%{__cp} -p maven2-brew/com/google/inject/extensions/guice-multibindings/%{namedversion}/guice-multibindings-%{namedversion}-tests.jar %{buildroot}%{_javadir}/guice-multibindings-%{namedversion}-tests.jar
%{__cp} -p maven2-brew/com/google/inject/extensions/guice-multibindings/%{namedversion}/guice-multibindings-%{namedversion}.jar %{buildroot}%{_javadir}/guice-multibindings-%{namedversion}.jar
%{__cp} -p maven2-brew/com/google/inject/extensions/guice-persist/%{namedversion}/guice-persist-%{namedversion}-tests.jar %{buildroot}%{_javadir}/guice-persist-%{namedversion}-tests.jar
%{__cp} -p maven2-brew/com/google/inject/extensions/guice-persist/%{namedversion}/guice-persist-%{namedversion}.jar %{buildroot}%{_javadir}/guice-persist-%{namedversion}.jar
%{__cp} -p maven2-brew/com/google/inject/extensions/guice-servlet/%{namedversion}/guice-servlet-%{namedversion}-tests.jar %{buildroot}%{_javadir}/guice-servlet-%{namedversion}-tests.jar
%{__cp} -p maven2-brew/com/google/inject/extensions/guice-servlet/%{namedversion}/guice-servlet-%{namedversion}.jar %{buildroot}%{_javadir}/guice-servlet-%{namedversion}.jar
%{__cp} -p maven2-brew/com/google/inject/extensions/guice-spring/%{namedversion}/guice-spring-%{namedversion}-tests.jar %{buildroot}%{_javadir}/guice-spring-%{namedversion}-tests.jar
%{__cp} -p maven2-brew/com/google/inject/extensions/guice-spring/%{namedversion}/guice-spring-%{namedversion}.jar %{buildroot}%{_javadir}/guice-spring-%{namedversion}.jar
%{__cp} -p maven2-brew/com/google/inject/extensions/guice-throwingproviders/%{namedversion}/guice-throwingproviders-%{namedversion}-tests.jar %{buildroot}%{_javadir}/guice-throwingproviders-%{namedversion}-tests.jar
%{__cp} -p maven2-brew/com/google/inject/extensions/guice-throwingproviders/%{namedversion}/guice-throwingproviders-%{namedversion}.jar %{buildroot}%{_javadir}/guice-throwingproviders-%{namedversion}.jar
%{__cp} -p maven2-brew/com/google/inject/guice/%{namedversion}/guice-%{namedversion}-no_aop.jar %{buildroot}%{_javadir}/guice-%{namedversion}-no_aop.jar
%{__cp} -p maven2-brew/com/google/inject/guice/%{namedversion}/guice-%{namedversion}-no_deps.jar %{buildroot}%{_javadir}/guice-%{namedversion}-no_deps.jar
%{__cp} -p maven2-brew/com/google/inject/guice/%{namedversion}/guice-%{namedversion}-tests.jar %{buildroot}%{_javadir}/guice-%{namedversion}-tests.jar
%{__cp} -p maven2-brew/com/google/inject/guice/%{namedversion}/guice-%{namedversion}.jar %{buildroot}%{_javadir}/guice-%{namedversion}.jar
(cd %{buildroot}%{_javadir} && for jar in *-%{namedversion}*; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed} -e "s|-%{namedversion}||g"`; done)

# poms
%{__mkdir_p} %{buildroot}%{_datadir}/maven2/poms
%{__cp} -p maven2-brew/com/google/inject/extensions/extensions-parent/%{namedversion}/extensions-parent-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP-extensions-parent.pom
%{__cp} -p maven2-brew/com/google/inject/extensions/guice-assistedinject/%{namedversion}/guice-assistedinject-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP-guice-assistedinject.pom
%{__cp} -p maven2-brew/com/google/inject/extensions/guice-grapher/%{namedversion}/guice-grapher-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP-guice-grapher.pom
%{__cp} -p maven2-brew/com/google/inject/extensions/guice-jmx/%{namedversion}/guice-jmx-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP-guice-jmx.pom
%{__cp} -p maven2-brew/com/google/inject/extensions/guice-jndi/%{namedversion}/guice-jndi-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP-guice-jndi.pom
%{__cp} -p maven2-brew/com/google/inject/extensions/guice-multibindings/%{namedversion}/guice-multibindings-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP-guice-multibindings.pom
%{__cp} -p maven2-brew/com/google/inject/extensions/guice-persist/%{namedversion}/guice-persist-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP-guice-persist.pom
%{__cp} -p maven2-brew/com/google/inject/extensions/guice-servlet/%{namedversion}/guice-servlet-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP-guice-servlet.pom
%{__cp} -p maven2-brew/com/google/inject/extensions/guice-spring/%{namedversion}/guice-spring-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP-guice-spring.pom
%{__cp} -p maven2-brew/com/google/inject/extensions/guice-throwingproviders/%{namedversion}/guice-throwingproviders-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP-guice-throwingproviders.pom
%{__cp} -p maven2-brew/com/google/inject/guice-parent/%{namedversion}/guice-parent-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP-guice-parent.pom
%{__cp} -p maven2-brew/com/google/inject/guice/%{namedversion}/guice-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP-guice.pom

# depmaps
%add_to_maven_depmap com.google.inject.extensions extensions-parent %{namedversion} JPP extensions-parent
%add_to_maven_depmap com.google.inject.extensions guice-assistedinject %{namedversion} JPP guice-assistedinject
%add_to_maven_depmap com.google.inject.extensions guice-grapher %{namedversion} JPP guice-grapher
%add_to_maven_depmap com.google.inject.extensions guice-jmx %{namedversion} JPP guice-jmx
%add_to_maven_depmap com.google.inject.extensions guice-jndi %{namedversion} JPP guice-jndi
%add_to_maven_depmap com.google.inject.extensions guice-multibindings %{namedversion} JPP guice-multibindings
%add_to_maven_depmap com.google.inject.extensions guice-persist %{namedversion} JPP guice-persist
%add_to_maven_depmap com.google.inject.extensions guice-servlet %{namedversion} JPP guice-servlet
%add_to_maven_depmap com.google.inject.extensions guice-spring %{namedversion} JPP guice-spring
%add_to_maven_depmap com.google.inject.extensions guice-throwingproviders %{namedversion} JPP guice-throwingproviders
%add_to_maven_depmap com.google.inject guice-parent %{namedversion} JPP guice-parent
%add_to_maven_depmap com.google.inject guice %{namedversion} JPP guice
%else
# jars
%{__mkdir_p} %{buildroot}%{_javadir}
for name in guice; do
    %{__cp} -p build/dist/${name}-%{namedversion}.jar %{buildroot}%{_javadir}/${name}-%{namedversion}.jar
    %{__cp} -p build/${name}-%{namedversion}-src.jar %{buildroot}%{_javadir}/${name}-%{namedversion}-src.jar
done
for name in guice-assistedinject guice-grapher guice-jmx guice-jndi guice-multibindings guice-persist guice-servlet guice-spring guice-struts2-plugin guice-throwingproviders; do
    %{__cp} -p build/dist/${name}-%{namedversion}.jar %{buildroot}%{_javadir}/${name}-%{namedversion}.jar
    %{__cp} -p build/dist/${name}-%{namedversion}-src.jar %{buildroot}%{_javadir}/${name}-%{namedversion}-src.jar
done
(cd %{buildroot}%{_javadir} && for jar in *-%{namedversion}*; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed} "s|-%{namedversion}||g"`; done)

# poms
mkdir -p %{buildroot}%{_datadir}/maven2/poms
%{__cp} -p core/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-guice.pom
%{__cp} -p pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-guice-parent.pom
%{__cp} -p extensions/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-guice-extensions-parent.pom
%add_to_maven_depmap com.google.inject guice %{namedversion} JPP guice
%add_to_maven_depmap com.google.inject guice-parent %{namedversion} JPP guice-parent
%add_to_maven_depmap com.google.inject.extensions extensions-parent %{namedversion} JPP guice-extensions-parent
for name in assistedinject grapher jmx jndi multibindings persist servlet spring struts2 throwingproviders; do
    %{__cp} -p extensions/${name}/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-guice-${name}.pom
    %add_to_maven_depmap com.google.inject.extensions guice-${name} JPP guice-${name}
done
%endif

# javadoc
mkdir -p %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%if %with maven
%{__cp} -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%else
%{__cp} -pr build/docs/javadoc/* %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%endif
%{__ln_s} %{name}-%{namedversion} %{buildroot}%{_javadocdir}/%{name}

%if %with repolib
%if %with maven
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com
%{__cp} -pr maven2-brew %{buildroot}%{_javadir}/repository.jboss.com
%else
export MAVEN_REPO_LOCAL=`pwd`/.m2/repository
export URL=file://%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
for name in guice-parent guice-extensions-parent; do
    %{_bindir}/mvn-jpp deploy:deploy-file -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DpomFile=%{buildroot}%{_datadir}/maven2/poms/JPP-${name}.pom -Dfile=%{buildroot}%{_datadir}/maven2/poms/JPP-${name}.pom -Durl=${URL} -DrepositoryId=oss-releases
done
for name in guice guice-assistedinject guice-grapher guice-jmx guice-jndi guice-multibindings guice-persist guice-servlet guice-spring guice-throwingproviders; do
    %{_bindir}/mvn-jpp deploy:deploy-file -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DpomFile=%{buildroot}%{_datadir}/maven2/poms/JPP-${name}.pom -Dfile=%{buildroot}%{_javadir}/${name}-%{namedversion}.jar -Durl=${URL} -DrepositoryId=oss-releases
    %{_bindir}/mvn-jpp deploy:deploy-file -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DpomFile=%{buildroot}%{_datadir}/maven2/poms/JPP-${name}.pom -Dfile=%{buildroot}%{_javadir}/${name}-%{namedversion}-src.jar -Dclassifier=src -Durl=${URL} -DrepositoryId=oss-releases
done
%endif
%endif

%clean
%{__rm} -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%{_javadir}*/guice-assistedinject-%{namedversion}-tests.jar
%{_javadir}*/guice-assistedinject-tests.jar
%{_javadir}*/guice-assistedinject-%{namedversion}.jar
%{_javadir}*/guice-assistedinject.jar
%{_javadir}*/guice-grapher-%{namedversion}-tests.jar
%{_javadir}*/guice-grapher-tests.jar
%{_javadir}*/guice-grapher-%{namedversion}.jar
%{_javadir}*/guice-grapher.jar
%{_javadir}*/guice-jmx-%{namedversion}-tests.jar
%{_javadir}*/guice-jmx-tests.jar
%{_javadir}*/guice-jmx-%{namedversion}.jar
%{_javadir}*/guice-jmx.jar
%{_javadir}*/guice-jndi-%{namedversion}-tests.jar
%{_javadir}*/guice-jndi-tests.jar
%{_javadir}*/guice-jndi-%{namedversion}.jar
%{_javadir}*/guice-jndi.jar
%{_javadir}*/guice-multibindings-%{namedversion}-tests.jar
%{_javadir}*/guice-multibindings-tests.jar
%{_javadir}*/guice-multibindings-%{namedversion}.jar
%{_javadir}*/guice-multibindings.jar
%{_javadir}*/guice-persist-%{namedversion}-tests.jar
%{_javadir}*/guice-persist-tests.jar
%{_javadir}*/guice-persist-%{namedversion}.jar
%{_javadir}*/guice-persist.jar
%{_javadir}*/guice-servlet-%{namedversion}-tests.jar
%{_javadir}*/guice-servlet-tests.jar
%{_javadir}*/guice-servlet-%{namedversion}.jar
%{_javadir}*/guice-servlet.jar
%{_javadir}*/guice-spring-%{namedversion}-tests.jar
%{_javadir}*/guice-spring-tests.jar
%{_javadir}*/guice-spring-%{namedversion}.jar
%{_javadir}*/guice-spring.jar
%{_javadir}*/guice-throwingproviders-%{namedversion}-tests.jar
%{_javadir}*/guice-throwingproviders-tests.jar
%{_javadir}*/guice-throwingproviders-%{namedversion}.jar
%{_javadir}*/guice-throwingproviders.jar
%{_javadir}*/guice-%{namedversion}-no_aop.jar
%{_javadir}*/guice-no_aop.jar
%{_javadir}*/guice-%{namedversion}-no_deps.jar
%{_javadir}*/guice-no_deps.jar
%{_javadir}*/guice-%{namedversion}-tests.jar
%{_javadir}*/guice-tests.jar
%{_javadir}*/guice-%{namedversion}.jar
%{_javadir}*/guice.jar
%{_datadir}/maven2/poms/JPP-extensions-parent.pom
%{_datadir}/maven2/poms/JPP-guice-assistedinject.pom
%{_datadir}/maven2/poms/JPP-guice-grapher.pom
%{_datadir}/maven2/poms/JPP-guice-jmx.pom
%{_datadir}/maven2/poms/JPP-guice-jndi.pom
%{_datadir}/maven2/poms/JPP-guice-multibindings.pom
%{_datadir}/maven2/poms/JPP-guice-persist.pom
%{_datadir}/maven2/poms/JPP-guice-servlet.pom
%{_datadir}/maven2/poms/JPP-guice-spring.pom
%{_datadir}/maven2/poms/JPP-guice-throwingproviders.pom
%{_datadir}/maven2/poms/JPP-guice-parent.pom
%{_datadir}/maven2/poms/JPP-guice.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{namedversion}
%{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%exclude %dir %{_javadocdir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Thu Sep 22 2011 David Walluck <dwalluck@redhat.com> 0:3.0-2
- patch for new google-parent
- set MAVEN_OPTS

* Mon Sep 19 2011 David Walluck <dwalluck@redhat.com> 0:3.0-1
- 3.0

* Thu May 26 2011 Ralph Apel <r.apel@r-apel.de> 0:2.0-2
- Add -servlet and -spring artifacts

* Thu Dec 23 2010 David Walluck <dwalluck@redhat.com> 0:2.0-1
- 2.0

* Mon Aug 11 2008 Ralph Apel <r.apel at r-apel.de> 0:1.0-0.RC2.1.jpp5
- Initial release
